/*
 * @Description: 
 * @Author: 王强
 * @Date: 2022-09-08 22:02:48
 * @LastEditTime: 2022-09-14 22:44:14
 * @LastEditors: 王强
 */
import { boundingExtent, getCenter } from 'ol/extent'
/**
 * base64 转换为 blob数据
 * @param base64Data
 * @param type
 * @returns {Blob}
 */
export function base64ToBlob (base64Data, type) {
  base64Data = base64Data || ''
  let arr = base64Data.split(','),
    buster = atob(arr[0]),
    l = buster.length,
    u8Arr = new Uint8Array(l)
  while (l--) {
    u8Arr[l] = buster.charCodeAt(l)
  }
  //type: 'application/pdf'
  return new Blob([u8Arr], { type })
}

/**
 * @description: 
 * @return {*}
 * @Author: 王强
 * @Date: 2022-09-08 20:37:03
 * @LastEditTime: Do not edit
 * @LastEditors: 王强
 * @param {*} key
 * @param {*} params
 */
export function validateParams (key, params = {}) {
  if (!Array.isArray(key)) {
    key = [key]
  }
  key.forEach(k => {
    if (!params.hasOwnProperty(k)) {
      throw new Error(k + ' is Required')
    }
  })
}

/**
 * @description: 获取几何边界的中心点
 * @return {*}
 * @Author: 王强
 * @Date: 2022-09-08 20:44:47
 * @LastEditTime: Do not edit
 * @LastEditors: 王强
 * @param {*} coordinates
 */
export function getCenterFromCoordinates (coordinates) {
  const extent = boundingExtent(coordinates)
  const center = getCenter(extent) // 获取边界区域的中心位置
  return center
}