/*
 * @Description: 
 * @Author: 王强
 * @Date: 2022-09-08 22:02:48
 * @LastEditTime: 2022-09-14 21:54:58
 * @LastEditors: 王强
 */
import {
  LineString,
  Polygon
} from 'ol/geom.js' // , Point
import {
  getArea,
  getLength
} from 'ol/sphere.js'
export function measure (map, geom, type) {
  if (type === 'area') {

    return measureArea(map, geom)
  }
  if (type === 'length') {
    return measureLength(map, geom)
  }
}

export function measureArea (map, geom) {
  if (!(geom instanceof Polygon)) {
    throw new Error("geom should instanceof Polygon")
  }
  const projection = map.getView().getProjection()
  const area = getArea(geom, { projection: projection })
  let output
  let unit
  if (area > 10000) {
    output = (Math.round(area / 1000000 * 100) / 100)
    unit = "km<sup>2</sup>"
  } else {
    output = (Math.round(area * 100) / 100)
    unit = "m<sup>2</sup>"
  }
  return {
    value: output,
    unit: unit
  }
}

export function measureLength (map, geom) {
  if (!(geom instanceof LineString)) {
    throw new Error("geom should instanceof LineString")
  }
  const projection = map.getView().getProjection()
  const length = getLength(geom, { projection: projection })
  let output
  let unit
  if (length > 100) {
    output = (Math.round(length / 1000 * 100) / 100)
    unit = 'km'
  } else {
    output = (Math.round(length * 100) / 100)
    unit = 'm'
  }
  return {
    value: output,
    unit: unit
  }
}

export default measure